﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Controls;
using System.Windows;
using Rifts.Models.Definitions;

namespace Rifts.Creator
{
	/// <summary>
	/// Interaction logic for SecondarySkills.xaml
	/// </summary>
	public partial class SecondarySkills : Page
	{
		public SecondarySkills()
		{
			InitializeComponent();
			DataContextChanged += SecondarySkills_DataContextChanged;
		}

		void SecondarySkills_DataContextChanged(object sender, DependencyPropertyChangedEventArgs e)
		{
			Reset();
			TypedDataContext.ResetAction = Reset;
		}

		public CreatorViewModel TypedDataContext
		{
			get { return (CreatorViewModel)DataContext; }
		}


		private void Button_Click(object sender, RoutedEventArgs e)
		{
			var skillDefinition = (SkillDefinitionViewModel)((FrameworkElement)sender).DataContext;
			TypedDataContext.ApplySecondarySkill(skillDefinition);
			if (TypedDataContext.SecondarySkills.All(innerList => innerList.All(s => !s.MetRequirements)))
				TypedDataContext.CanMoveNext = true;
		}

		private void Reset()
		{
			TypedDataContext.Character.RejectChanges();
			TypedDataContext.SecondarySkills.Clear();
			TypedDataContext.SecondarySkills.AddRange(TypedDataContext.SelectedClass.SecondarySkills());
			TypedDataContext.SecondarySkillPicks = TypedDataContext.Character.SecondarySkillsFromIQ(TypedDataContext.SelectedClass.SecondarySkillPicks, TypedDataContext.Random);
			TypedDataContext.UpdateSecondarySkills();
			TypedDataContext.CanMoveNext = false;
		}


	}
}
